// Copyright (c) 2008
// verso 1.0 desenvolvido por Sidnei Cruz
// (sob orientao de Doutor Pedro Quaresma)


#include "cifraDS.h"
#include "alfabeto.h"
#include "funcoes_auxiliares.h"


/*funo que vai encriptar a mensagem 
  -> parmetro de entrada: o valor do caracter e a chave para encripatar o caracter
  <- parmetro de saida: o valor do caracter encriptado ou sem encripatar
*/
int encriptarDS(int m,int chave){ 
  int valornoalfabeto,encriptar,valoriso; 
  //obter o valor do caracter no Alfabeto 
  valornoalfabeto=entradaParaAlfabeto(m);
  //verificar se o caracter pertence ao Alfabeto 
  if(valornoalfabeto!= NAOALFA){ 
    encriptar=cifrarDS(valornoalfabeto,chave); 
    //obter o valor do caracter no ISO8859_1 
    valoriso=alfabetoParaSaida(encriptar);
    return valoriso;
  }
  else 
    return m; 
} 



/*funo que vai desencriptar a mensagem 
  -> parmetro de entrada: o valor do caracter e a chave para desencripatar o caracter
  <- parmetro de saida: o valor do caracter desencriptado ou o valor do caracter de entrada na funo
*/
int desencriptarDS(int c,int chave){ 
  int valornoalfabeto,desencriptar,valoriso,diferenca; 
  valornoalfabeto=entradaParaAlfabeto(c); 
  if(valornoalfabeto!=NAOALFA){
    diferenca=decifrarDS(valornoalfabeto,chave);
    desencriptar=mod(diferenca,COMPALFA); 
    valoriso=alfabetoParaSaida(desencriptar); 
    return valoriso; 
  }
  else{
    return c;
  }
}



/*
  Cifra de Deslocamento Simples

  -> parmetro de entrada:um inteiro com o valor do caracter e a chave
  para encriptar
  <- parmetro de saida: o valor do carcter encriptado
*/
int cifrarDS(int m,int c){
  
  return((m + c) % COMPALFA);
  
}


/*
  Cifra de Deslocamento Simples (funo inversa)

  -> parmetro de entrada: um inteiro com o valor do caracter e a
  chave para desencriptar
  <- parmetro de saida: o valor do carcter desencriptado
*/
int decifrarDS(int e,int c){
  
  return((e - c) % COMPALFA);
  
}




