// Copyright (c) 2008
// verso 1.0 desenvolvido por Sidnei Cruz
// (sob orientao de Doutor Pedro Quaresma)

#include <stdio.h>
#include <string.h> // permite a utilizao de funcoes que manipulam strings 
#include <stdlib.h> // biblioteca para funcao exit
#include "cifraDS.h"
#include "alfabeto.h"
#include "funcoes_auxiliares.h"


int main(int argc, char *argv[]){
  
  //fl -> o ficheiro de entrada(leitura) 
  //fe -> o ficheiro de saida(escrita)
  
  FILE *fl,*fe;
  
  //verificar o nmero de argumento
  if(argc!=4){
    printf("\nUtilizaao: desencriptarDS nome_ficheiro_entrada chave nome_ficheiro_saida\n\n");
    exit(1);
  }
  
  //Declarao das variveis
  char *menscifrada, *mensdecifrada;
  int ch;
  int caracter;
  int resultado;
  int chave;
  
  //cpia do ficheiro de entrada
  menscifrada = argv[1];
  
 
  //funcao atoi recebe uma string e devolve o inteiro que nela esta representado
  chave=atoi(argv[2]);
  
  //fazer copia
  mensdecifrada = argv[3];
  
  //abrir o ficheiro para a leitura
  fl = fopen(menscifrada,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl==NULL){
    printf("Impossivel abrir o ficheiro %s\n",argv[1]);
    exit(2);
  }
  
  //Abrir o ficheiro para escrever a mensagem decifrada
  if((fe = fopen(mensdecifrada,"w"))==NULL){
    printf("Impossivel criar o ficheiro %s\n",mensdecifrada);
    exit(3);
  }
  
  //Aplicar a Cifra de Deslocamento Simples
  while((ch=fgetc(fl))!=EOF){
    resultado=desencriptarDS(ch,chave);
    fprintf(fe,"%c",resultado);
  }
  
  
  //Fechar os ficheiros
  fclose(fl);
  fclose(fe);
  
  exit(0);
  
}
